{ lib
, buildGoModule
, fetchFromGitHub
, installShellFiles
}:

let version = "2022-12-01"; in

buildGoModule {
  pname = "d2";
  inherit version;

  src = fetchFromGitHub {
    owner = "terrastruct";
    repo = "d2";
    rev = "0cb71095b74c71d2c22f297ff41340867e871f1a";
    sha256 = "sha256-2TOtVWtqMiPmks7olaXyuvfqIEGsqw1yRRY92sV2v1M=";
  };

  vendorSha256 = "sha256-uOdUQaUuL48ltJl6YTg1a8v8GmacZpW5OtZafXqjQUo=";

  ldflags = [
    "-s"
    "-w"
    "-X oss.terrastruct.com/d2/lib/version.Version=${version}"
  ];

  nativeBuildInputs = [ installShellFiles ];

  patches = [
    ../patches/d2/self_referencing_connections.patch
  ];

  postInstall = "installManPage ci/release/template/man/d2.1";

  subPackages = [ "." ];
}
